﻿using HarmonyLib;
using UnityEngine;

public class BetterPause : Mod
{
    private static BetterPause instance;
    Harmony harmony;

    private bool wasPaused = false;
    static bool godmodeWhilePaused;
    public static bool GodmodeWhilePaused => ExtraSettingsAPI_Loaded ? godmodeWhilePaused : true;
    private float stat_thirst, stat_thirst_bonus, stat_hunger, stat_hunger_bonus;

    public void Start()
    {
        instance = this;

        harmony = new Harmony("net.hypexmon5ter.BetterPause");
        harmony.PatchAll();

        Debug.Log("Mod BetterPause has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);

        Debug.Log("Mod BetterPause has been unloaded!");
    }

    static bool ExtraSettingsAPI_Loaded = false;

    public void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();
    public void ExtraSettingsAPI_SettingsClose()
    {
        godmodeWhilePaused = ExtraSettingsAPI_GetCheckboxState("godmodeWhilePaused");
    }

    public bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;


public void Update()
    {
        bool paused = CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu);

        if (paused)
        { 
            if (!wasPaused)
            {
                stat_thirst = RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value;
                stat_thirst_bonus = RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value;
                stat_hunger = RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value;
                stat_hunger_bonus = RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value;
            }
            else
            {
                stat_thirst = Mathf.Max(stat_thirst, RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value);
                stat_thirst_bonus = Mathf.Max(stat_thirst_bonus, RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value);
                stat_hunger = Mathf.Max(stat_hunger, RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value);
                stat_hunger_bonus = Mathf.Max(stat_hunger_bonus, RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value);
                    
            }
            RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value = stat_thirst;
            RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value = stat_thirst_bonus;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value = stat_hunger;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value = stat_hunger_bonus;
        }
        wasPaused = paused;
    }
}

[HarmonyPatch(typeof(BuffDisplayObject), "Update")]
public class Patch_BuffDisplayObject
{
    [HarmonyPrefix]
    static bool Postfix()
    {
        if (CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu))
        {
            return false;
        }
        return true;
    }
}

[HarmonyPatch(typeof(Network_Entity), "Damage")]
public class Patch_Damage
{
    [HarmonyPrefix]
    static bool Postfix()
    {
        if (CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu) && BetterPause.GodmodeWhilePaused)
        {
            return false;
        }
        return true;
    }
}